﻿namespace PristaniNaMesici
{
    using System;
    using System.Net;
    using System.Threading.Tasks;

    public class Game
    {
        private string address;
        private WebClient wc = new WebClient();
        public int Id;
        public double L, R, U;

        public Game(string address)
        {
            this.address = address;
        }

        public Response Start()
        {
            var response = this.GetResponse("start");
            this.Id = response.ID;
            return response;
        }

        public Response Check()
        {
            return this.GetResponse($"stav?id={this.Id}&doleva={L}&doprava={R}&nahoru={U}");
        }

        public Response CheckFast()
        {
            return this.GetResponseFast($"stav?id={this.Id}&doleva={L}&doprava={R}&nahoru={U}");
        }

        public void SetMotors(double left, double right, double up)
        {
            this.L = left;
            this.R = right;
            this.U = up;
        }

        private Response GetResponseFast(string parameters)
        {
            try
            {
                var request = $"http://{this.address}/{parameters}";
                var responseString = new WebClient().DownloadString(request);

                return new Response(responseString);
            }
            catch (Exception ex)
            {
                return new Response(ex.Message, true);
            }
        }

        private Response GetResponse(string parameters)
        {
            try
            {
                var request = $"http://{this.address}/{parameters}";
                var responseString = wc.DownloadString(request);

                return new Response(responseString);
            }
            catch (Exception ex)
            {
                return new Response(ex.Message, true);
            }
        }
    }
}
