﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PristaniNaMesici
{
    using System.Runtime.InteropServices.ComTypes;
    using System.Timers;

    public class GameSolver
    {
        public Game game;
        private Timer timer;
        private double maxSpeed;
        private double minusMaxSpeed;
        private int precision = 1;

        public GameSolver(Game game, double maxSpeed)
        {
            this.game = game;
            if (maxSpeed != 0)
                precision = 3;
            if (maxSpeed > 5 || maxSpeed == 0)
                maxSpeed = 5;
            this.maxSpeed = maxSpeed - 0.1 * precision;
            this.minusMaxSpeed = (-1 * maxSpeed) + 0.1 * precision;
        }

        public string Solve()
        {
            var c = game.Start();

            while (c.GameResult == null)
            {
                if (c.VY < minusMaxSpeed)
                    game.U = 1;
                else if (c.VY > minusMaxSpeed + 0.1 * precision)
                    game.U = 0;

                if (c.X - 10 < c.L || c.X + 10 > c.R)
                {
                    if (c.X - 10 < c.L)
                        RightMotorOn();
                    
                    else if (c.X + 10 > c.R)
                        LeftMotorOn();
                }
                else
                {
                    if (c.VX > 0.3)
                        LeftMotorOn();
                    
                    else if (c.VX < -0.3 * precision)
                        RightMotorOn();
                }

                c = game.CheckFast();
            }

            return c.GameResult;
        }

        private void LeftMotorOn()
        {
            game.L = 1;
            game.R = 0;
        }

        private void RightMotorOn()
        {
            game.R = 1;
            game.L = 0;
        }
    }
}
